Type=Class
Version=4.7
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
'Class module
Sub Class_Globals
	<smtp>
	Private ws As WebSocket 'ignore
	' will hold our page information
	Public page As ABMPage
	' page theme
	Private theme As ABMTheme
	' to access the constants
	Private ABM As ABMaterial 'ignore	
	' name of the page, must be the same as the class name (case sensitive!)
	Public Name As String = "<PageName>"  '<-------------------------------------------------------- IMPORTANT
	Private ABMPageId As String = ""
	
	' your own variables
	Dim Origin As String = "<webaddress>" '<--- IMPORTANT for youtube videos.  Set here your website address
	' the download folder
	Public DownloadFolder As String = "/www/" & ABMShared.AppName & "/uploads/"
	Public DownloadMaxSize As String = 100*1024
	Private myToastId As Int
	Private dbAction As Map
	Private ActiveID As Int
	private IsNew As Boolean
	Private Filter As String
	Private LastSort As String
	Private FilterCount As String
	Private OldValue As String
	Dim CurrentValues As List
	Dim CurrentLabels As List
	Public MaxRows As Int = 10
	<SyncfusionChart>
	<SyncfusionGantt>
	<JustGage>
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize()
	' build the local structure IMPORTANT!
	BuildPage
End Sub

Private Sub WebSocket_Connected (WebSocket1 As WebSocket)
	'----------------------MODIFICATION-------------------------------	
	Log("Connected")
	ws = WebSocket1		
	ABMPageId = ABM.GetPageID(page, Name,ws)
	Dim session As HttpSession = ABM.GetSession(ws, ABMShared.SessionMaxInactiveIntervalSeconds)	
	
	If ABMShared.NeedsAuthorization Then
	   If session.GetAttribute2("IsAuthorized", "") = "" Then
	      ABMShared.NavigateToPage(ws, ABMPageId, "../")
	      Return
	   End If
	End If		
	
	ABM.UpdateFromCache(Me, ABMShared.CachedPages, ABMPageId, ws)
	If page.ComesFromPageCache Then
    	   ' when we have a page that is cached it doesn't matter if it comes or not from a new connection we serve the cached version.
	   Log("Comes from cache")
    	   page.Refresh
    	   page.FinishedLoading
	Else
    	   If page.WebsocketReconnected Then
	      Log("Websocket reconnected")
             ' when we have a client that doesn't have the page in cache and it's websocket reconnected and also it's session is new - basically when the client 
	      ' had internet problems and it's session (and also cache) expired before he reconnected so the user has content in the browser but we don't have 
             ' any on the server. So we need to reload the page.
             ' when a client that doesn't have the page in cache and it's websocket reconnected but it's session is not new - when the client had internet 
	      ' problems and when he reconnected it's session was valid but he had no cache for this page we need to reload the page as the user browser has 
             ' content, reconnected but we have no content in cache
             ABMShared.NavigateToPage (ws, ABMPageId, "./" & page.PageHTMLName)
    	   Else
             ' when the client did not reconnected it doesn't matter if the session was new or not because this is the websockets first connection so no dynamic 
             ' content in the browser ... we are going to serve the dynamic content...
             Log("Websocket first connection")
	      page.Prepare
             ConnectPage
    	   End If
	End If
	Log(ABMPageId)	
	'----------------------MODIFICATION-------------------------------	
End Sub


Private Sub WebSocket_Disconnected()
	Log("Disconnected")
    Try		
		ws.Session.RemoveAttribute("abmcallback")	
		ws.Session.RemoveAttribute("abmdownloadfolder")
		ws.Session.RemoveAttribute("abmmaxsize")		
	Catch
		Log(LastException.Message)
	End Try
End Sub

Sub Page_ParseEvent(Params As Map) 
	Dim eventName As String = Params.Get("eventname")
	Dim eventParams() As String = Regex.Split(",",Params.Get("eventparams"))
If eventName = "beforeunload" Then
		Log("preparing for url refresh")
		ABM.RemoveMeFromCache(ABMShared.CachedPages, ABMPageId)	
		Return
	End If
	If SubExists(Me, eventName) Then
		Params.Remove("eventname")
		Params.Remove("eventparams")
		Select Case Params.Size
			Case 0
				CallSub(Me, eventName)
			Case 1
				CallSub2(Me, eventName, Params.Get(eventParams(0)))					
			Case 2
				If Params.get(eventParams(0)) = "abmistable" Then
					Dim PassedTables As List = ABM.ProcessTablesFromTargetName(Params.get(eventParams(1)))
					CallSub2(Me, eventName, PassedTables)
				Else
					CallSub3(Me, eventName, Params.Get(eventParams(0)), Params.Get(eventParams(1)))
				End If
			Case Else
				' cannot be called diretly, to many param
				CallSub2(Me, eventName, Params)				
		End Select
	End If
End Sub

public Sub BuildTheme()
	' start with the base theme defined in ABMShared
	theme.Initialize("<PageTheme>")
	theme.AddABMTheme(ABMShared.MyTheme)
	
	' add additional themes specific for this page
	theme.Page.BackColor = <BackColor>
	theme.Page.BackColorIntensity = <BackColorIntensity>
	theme.Page.ConnectedIndicatorColor = <ConnectedIndicatorColor>
	theme.Page.ConnectedIndicatorColorIntensity = <ConnectedIndicatorColorIntensity>
	theme.Page.DisconnectedIndicatorColor = <DisconnectedIndicatorColor>
	theme.Page.DisconnectedIndicatorColorIntensity = <DisconnectedIndicatorColorIntensity>
	theme.Page.PlaceHolderColor = <PlaceHolderColor>
	theme.Page.PlaceHolderColorIntensity = <PlaceHolderColorIntensity>
End Sub

public Sub BuildPage()
	' initialize the theme
	BuildTheme
	
	' initialize this page using our theme
	page.InitializeWithTheme(Name, "/ws/" & ABMShared.AppName & "/" & Name, False, ABMShared.SessionMaxInactiveIntervalSeconds, theme)
	page.ShowLoader=<ShowLoader>
	page.ShowLoaderType=<ShowLoaderType>
	<buildloader>
	page.PageHTMLName = "<PageHTMLName>"
	page.PageTitle = "<PageTitle>"
	page.PageDescription = "<PageDescription>"
	page.PageKeywords = "<PageKeywords>"
	page.PageSiteMapPriority = "<PageSiteMapPriority>"
	page.PageSiteMapFrequency = <PageSiteMapFrequency>
	'page.UseFontAwesome = <UseFontAwesome>
	page.DisableBackButton = <DisableBackButton>
	page.UseGoogleAnalytics(ABMShared.TrackingID, Null) ' IMPORTANT Change this to your own TrackingID !!!!!!!
	page.GoogleMapsAPIExtras = ABMShared.GoogleMapsAPIExtras
	page.IsFixedFooter = <IsFixedFooter>
	page.DisablePageReloadOnSwipeDown = <DisablePageReloadOnSwipeDown>
	page.ShowConnectedIndicator = <ShowConnectedIndicator>
	page.PageLanguage = "<PageLanguage>"
	<page.SetBackgroundImage>
	<needs>
	' adding a navigation bar
	<BuildNavigationBar>
	
	page.ShowGridInfo = <ShowGridInfo>		
	' create the page grid
	<Grid>
	page.BuildGrid 'IMPORTANT once you loaded the complete grid AND before you start adding components
	<BuildFooter>
	<ConnectFooter>
	' add a error box template if the name is not entered
	page.AddModalSheetTemplate(ABMShared.BuildWrongInputModalSheet(page))
	' add a modal sheet template for a yes no msgbox
	page.AddModalSheetTemplate(ABMShared.BuildMsgBoxYesNo(page))
	' add a modal sheet template for a  msgbox
	page.AddModalSheetTemplate(ABMShared.BuildMsgBox(page))
	<AddModalSheetTemplate>
	<StaticComponents>
End Sub

<ModalSheetTemplates>

Sub msgyes_Clicked(Target As String)
	Dim msg As ABMModalSheet = page.ModalSheet("confirm")		
	Dim msgyes As ABMButton = msg.Footer.Component("msgyes")
	dim strTag As String
	strTag = msgyes.Tag
	<YesNoProcess>
	page.CloseModalSheet("confirm")
End Sub

Sub msgok_Clicked(Target As String)
	page.CloseModalSheet("msgbox")
End Sub

Sub msgno_Clicked(Target As String)
	page.CloseModalSheet("confirm")	
End Sub

' clicked on the navigation bar
Sub Page_NavigationbarClicked(Action As String, Value As String)
	page.SaveNavigationBarPosition
	If Action = "LogOff" Then
		ABMShared.LogOff(page)
		Return
	End If
	<NavigationCode>
	ABMShared.NavigateToPage(ws, ABMPageId, Value)
End Sub

Sub Page_FileUploaded(FileName As String, success As Boolean)
	<FileClear>
	page.ws.Flush ' IMPORTANT
End Sub

Sub Page_ToastClicked(ToastId As String, Action As String)
	page.DismissToast(ToastId)
End Sub

Sub Page_ToastDismissed(ToastId As String)	
	
End Sub

Public Sub ConnectPage()
	'connect navigation bar
	ConnectNavigationBar
	Dim NowWH As String = ABM.GetBrowserWidthHeight(page)
	If NowWH <> "" And NowWH <> ";" Then
		Dim split() As String = Regex.Split(";", NowWH)
		Dim NewH As Int = split(1) - 350
		NewH = NewH / 50		
		NewH = NewH / 5
		NewH = NewH * 5
		If NewH >= 10 Then
			MaxRows = NewH
		End If
	End If
	<settitle>
	'add components for the page
	<Components>	
	
	<RefreshComponents>
	<Crud>
	<TableRefresh>
    ' this page uses uploads, so needs some settings	
    page.ws.session.SetAttribute("abmcallback", Me)	
    page.ws.session.SetAttribute("abmdownloadfolder", DownloadFolder)
    page.ws.session.SetAttribute("abmmaxsize", DownloadMaxSize)	
	
    page.Refresh ' IMPORTANT
	
	' NEW, because we use ShowLoaderType=ABM.LOADER_TYPE_MANUAL
	page.FinishedLoading 'IMPORTANT
	page.RestoreNavigationBarPosition
	<refreshtables>
End Sub

Sub Page_SignedOffSocialNetwork(Network As String, Extra As String)
	page.ws.Session.SetAttribute("UserID", "")
	page.ws.Session.SetAttribute("UserEmail", "")
	page.ws.Session.SetAttribute("authType", "")
	page.ws.Session.SetAttribute("authName", "")
	page.ws.Session.SetAttribute("IsAuthorized", "")
	ABMShared.NavigateToPage(ws,ABMPageId, "../")	
End Sub

<editrecord>

<events>

<gets>

<fetchcalendar>

<pagesource>

Sub ConnectNavigationBar()
	' Clear the dummies we created in BuildNavigationBar
	page.NavigationBar.Clear
	'connect the items in the navigation bar
	<ConnectNavigationBar>
	'refresh the navigation bar
	page.NavigationBar.Refresh ' IMPORTANT
End Sub
