﻿Type=Class
Version=5
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
Sub Class_Globals
	Dim ABM As ABMaterial
	Dim ABMComp As ABMCustomComponent
	Public Height As String
	Public Width As String
	Public Title As String
	Public LegendVisible As Boolean
	Public LegendTitle As String
	Public LegendPosition As String
	Private SeriesList As List
	Public YAxisLabelFormat As String
	Public YAxisTitle As String
	Public XAxisTitle As String
	Public XAxisLabelFormat As String
	Public IsResponsive As Boolean
	Public EnableZooming As Boolean
	Public HTML As String
	Public enableCanvasRendering As Boolean
	Public PrimaryXAxisValueType As String
	Public enable3D As Boolean
	Type SeriesObj(xname As String, yname As String, stype As String, Width As String, xy As Map, name As String, tooltipvisible As Boolean, fillColor As String, _
	enableAnimation As Boolean, 	markershape As String, markervisible As Boolean, markerdatalabelsvisible As Boolean)
	Type TypeEnum(line As String, column As String, area As String, bar As String, spline As String, pie As String)
	Public EnumType As TypeEnum
	Type LegendPositionEnum(left As String, right As String, top As String, bottom As String)
	Public EnumLegendPosition As LegendPositionEnum
	Type CommonSeriesOptionsObj(stype As String, enableAnimation As Boolean, markershape As String, markervisible As Boolean, markerdatalabelsvisible As Boolean, _
	tooltipvisible As Boolean, fillColor As String, Width As String)
	Public CommonSeriesOptions As CommonSeriesOptionsObj
	Public SubTitle As String
	Private iID As String
	Public YAxisLabelFormatLocale As Boolean
	Public toolTipInitialize As Boolean
End Sub

Sub Download(InternalPage As ABMPage)
	Dim sb As String
	sb = $"var chart = $("#${iID}").ejChart("instance");
		   chart.model.enableCanvasRendering = true;
		   chart.redraw();
		   var canvas = chart.export();
		   var lnk = canvas.toDataURL("image/png");
		   var url = lnk.replace(/^data:image\/[^;]/, 'data:application/octet-stream');
		   var a = document.createElement("a");
	  	   a.download = "${iID}.png";
	       a.href = url;
		   a.target = "_blank";
		   document.body.appendChild(a);
	       a.click();
		   document.body.removeChild(a);
		   delete a;
		   chart.model.enableCanvasRendering = false;
		   chart.redraw();"$
	InternalPage.ws.Eval(sb, Array As Object(ABMComp.ID))
End Sub

Sub AddXY(so As SeriesObj, x As String, y As String)
	Dim sb As StringBuilder
	sb.Initialize 
	sb.Append("{x: '")
	sb.Append(x)
	sb.Append("', y: ")
	sb.Append(y)
	sb.Append("}")
	so.xy.Put(x, sb.ToString)
End Sub

'build the series data
private Sub BuildXYSeriesData(so As SeriesObj) As String
	Dim sb As StringBuilder
	sb.Initialize
	sb.Append("[") 
	For Each strRecord As String In so.xy.Keys
		Dim rec As String = so.xy.Get(strRecord) 
		sb.Append(rec).Append(",") 
	Next
	sb.Remove(sb.Length-1,sb.Length)
	sb.Append("],")
	Return sb.tostring 
End Sub

'build the series to be added
Private Sub BuildXYSeries(so As SeriesObj) As String
	Dim sb As StringBuilder
	sb.Initialize
	sb.Append("{")
	sb.Append("points: ").Append(BuildXYSeriesData(so))
	sb.Append("name: '")
	sb.Append(so.Name)
	sb.Append("'")
	If so.Fillcolor.Length > 0 Then
		sb.Append(",fill:")
		sb.Append(QUOTE)
		sb.Append(so.Fillcolor)
		sb.Append(QUOTE) 
	End If
	If so.sType.Length > 0 Then
		sb.Append(",type: ")
		sb.Append("'")
		sb.Append(so.sType)
		sb.Append("'") 
	End If
'	If so.xname.Length > 0 Then
'		sb.Append("xName: ")
'		sb.Append(QUOTE)
'		sb.Append(so.xname)
'		sb.Append(QUOTE)
'		sb.Append(",")
'	End If
'	If so.yname.Length > 0 Then
'		sb.Append("yName: ")
'		sb.Append(QUOTE)
'		sb.Append(so.yname)
'		sb.Append(QUOTE)
'		sb.Append(",")
'	End If
	If so.tooltipvisible = True Then
		sb.Append(",tooltip: {visible: true}")
	End If
	If so.enableAnimation = True Then
		sb.Append(",enableAnimation: true")
	End If
	If so.markervisible = True Then
		sb.Append(",marker: {")
		sb.Append("visible: true,")
		sb.Append("shape: '").Append(so.markershape).Append("',")
		sb.Append("size: { height: 10, Width: 10 },")
		If so.markerdatalabelsvisible = True Then
			sb.Append("dataLabel: { visible: true }")
		End If
		sb.Append("}") 
	End If
	sb.Append("},").Append(CRLF)
	Return sb.tostring
End Sub

public Sub InitializeSeries(Series As SeriesObj)
	Series.Initialize 
	Series.xname = ""
	Series.stype = ""
	Series.Width = ""
	Series.yname = ""
	Series.name = ""
	Series.fillColor = ""
	Series.tooltipvisible = False
	Series.enableAnimation = False
	Series.markershape = ""
	Series.markervisible = False
	Series.markerdatalabelsvisible = False
	Series.xy.Initialize
End Sub


'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(InternalPage As ABMPage, ID As String)
	ABMComp.Initialize("ABMComp", Me, InternalPage, ID)
	PrimaryXAxisValueType = ""
	SeriesList.Initialize
	LegendVisible = True
	LegendTitle = ""
	enableCanvasRendering = False
	Width = "100%"
	Height = "100%" 
	enable3D = False
	IsResponsive = True
	EnumType.Initialize
	EnumType.column = "column"
	EnumType.line = "line"
	EnumType.area = "area" 
	EnumType.bar = "bar"
	EnumType.spline = "spline"
	EnumType.pie = "pie"
	LegendPosition = "bottom"
	EnableZooming = False
	YAxisLabelFormatLocale = False
	HTML = ""
	EnumLegendPosition.Initialize
	EnumLegendPosition.left = "left"
	EnumLegendPosition.right = "right"
	EnumLegendPosition.top = "top"
	EnumLegendPosition.bottom = "bottom"
	YAxisTitle = ""
	XAxisTitle = ""
	CommonSeriesOptions.Initialize 
	CommonSeriesOptions.enableAnimation = False
	CommonSeriesOptions.markerdatalabelsvisible = False
	CommonSeriesOptions.markershape = ""
	CommonSeriesOptions.stype = ""
	CommonSeriesOptions.tooltipvisible = False
	CommonSeriesOptions.Width = ""
	SubTitle = ""
	toolTipInitialize = False
End Sub

' runs when an object is created for the first time. Expects a valid html string
' will get surrounded by a div automatically
' in the html file:
Sub ABMComp_Build(internalID As String) As String
	iID = internalID
	Return $"<div id="${internalID}" style="width: ${Width}; height: ${Height};"></div>"$	
End Sub

Sub AddSeries(so As SeriesObj)
	SeriesList.Add(so)
End Sub

' Is useful to run some initalisation script. 
Sub ABMComp_FirstRun(InternalPage As ABMPage, internalID As String)
	'build the chart here and initialize it
	Dim sb As StringBuilder
	sb.Initialize 
	sb.Append("$(").Append(QUOTE).Append("#").Append(internalID).Append(QUOTE).Append(").ejChart();").Append(CRLF)
	HTML = BuildChart(internalID)
	sb.Append(HTML)
	InternalPage.ws.Eval(sb.tostring, Array As Object(ABMComp.ID))
	' flush not needed, it's done in the refresh method in the lib
End Sub

' runs when a refresh is called
Sub ABMComp_Refresh(InternalPage As ABMPage, internalID As String)
	' use these methods to adjust the object
	' ABM.HasClass
	' ABM.AddClass
	' ABM.RemoveClass
	
	' ABM.AddHTML
	' ABM.InsertHTMLAfter
	' ABM.RemoveHTML
	
	' ABM.GetProperty
	' ABM.SetProperty
	' ABM.RemoveProperty
	
	' ABM.GetStyleProperty
	' ABM.SetStyleProperty
	'set chart properties
	HTML = BuildChart(internalID)	
	' do some script stuff like you do in RunJavaScript
	InternalPage.ws.Eval(HTML, Null)	
End Sub


' do the stuff needed when the object is removed
Sub ABMComp_CleanUp(InternalPage As ABMPage, internalID As String)
	
End Sub

private Sub BuildChart(xid As String) As String
	Dim sb As StringBuilder
	sb.Initialize
	sb.Append("$(").Append(QUOTE).Append("#").Append(xid).Append(QUOTE).Append(").ejChart({").Append(CRLF)
	If YAxisLabelFormatLocale = True Then
		sb.append("axesLabelRendering: 'axesLabels',").append(crlf) 
	End if
	if toolTipInitialize = True Then
		sb.append("toolTipInitialize: 'tooltipFormat',").append(crlf) 
	End If
	'yaxis label format
	sb.Append("primaryYAxis:{").Append(CRLF)
	If YAxisLabelFormatLocale = false Then
		If YAxisLabelFormat.Length > 0 Then sb.Append("labelFormat: '").Append(YAxisLabelFormat).Append("',").Append(CRLF)
	End if
	If YAxisTitle.Length > 0 Then sb.Append("title: { text: '").Append(YAxisTitle).Append("'},").Append(CRLF)
	If PrimaryXAxisValueType.Length > 0 Then sb.Append("valueType: '").Append(PrimaryXAxisValueType).Append("',").Append(CRLF) 
	sb.Append("},").Append(CRLF)
	sb.Append("primaryXAxis:{").Append(CRLF)
	If XAxisTitle.Length > 0 Then sb.Append("title: { text: '").Append(XAxisTitle).Append("'},").Append(CRLF)
	If XAxisLabelFormat.Length > 0 Then sb.Append("labelFormat: '").Append(XAxisLabelFormat).Append("',").Append(CRLF)
	sb.Append("},").Append(CRLF)
	sb.Append("commonSeriesOptions: {").Append(CRLF)
	If CommonSeriesOptions.tooltipvisible = True Then
		sb.Append("tooltip: {visible: true},").Append(CRLF)
	End If
	If CommonSeriesOptions.enableAnimation = True Then
		sb.Append("enableAnimation: true,").Append(CRLF)
	End If
	If CommonSeriesOptions.stype.Length > 0 Then
		sb.Append("type: ")
		sb.Append("'")
		sb.Append(CommonSeriesOptions.stype)
		sb.Append("',").Append(CRLF) 
	End If
	If CommonSeriesOptions.markervisible = True Then
		sb.Append("marker: {")
			sb.Append("visible: true,").Append(CRLF)
			sb.Append("shape: '").Append(CommonSeriesOptions.markershape).Append("',").Append(CRLF)
			sb.Append("size: { height: 10, Width: 10 },").Append(CRLF)
			If CommonSeriesOptions.markerdatalabelsvisible = True Then
				sb.Append("dataLabel: { visible: true },").Append(CRLF)
			End If
		sb.Append("},").Append(CRLF) 
	End If
	sb.Append("},").Append(CRLF)
	'set the title
	sb.Append("title: { text: '").Append(Title).Append("',")
	If SubTitle.length > 0 Then
	sb.append("subTitle: { text: '").append(SubTitle).append("', textAlignment: 'center'},")
	End If
	sb.append("},").Append(CRLF)
	sb.Append("series: [")
	For Each obj As SeriesObj In SeriesList
		Dim strSeries As String = BuildXYSeries(obj)
		sb.Append(strSeries).Append(CRLF)
	Next
	sb.Remove(sb.Length-1,sb.Length) 
	sb.Append("],").Append(CRLF)
	'set the legend
	sb.Append("legend: {").Append(CRLF)
	If LegendVisible = True Then 
		sb.Append("visible: true,").Append(CRLF)
		If LegendPosition.Length > 0 Then sb.append("position: '").Append(LegendPosition).Append("',").Append(CRLF)
		If LegendTitle.Length > 0 Then 
			sb.Append("title: {").Append(CRLF)
			sb.Append("text: ").append(QUOTE).append(LegendTitle).append(QUOTE).append(",").Append(CRLF)
			sb.Append("},").Append(CRLF)
		End If
	else
		sb.Append("visible: false,").Append(CRLF)
	End If
	sb.Append("},").Append(CRLF)
	If IsResponsive = True Then
		sb.Append("isResponsive: true,").Append(CRLF)
	End If
	If EnableZooming = True Then
		sb.Append("zooming: {enable: true},").Append(CRLF)
	End If
	If enableCanvasRendering = True Then
		sb.Append("enableCanvasRendering: true,").Append(CRLF) 
	End If
	If enable3D = True Then
		sb.Append("enable3D: true,").Append(CRLF)
	End If
	sb.append("exporting: { type: 'png', mode: 'client', fileName: 'ChartSnapshot' }").append(CRLF)
	'done with the chart
	sb.Append("});").Append(CRLF)
	Return sb.tostring
End Sub